#define MAXX     128
#define MAXY     128

#define CHARST  0
#define HILITE  1
#define BLOCK   2


#define BLOCKX  0x4
#define BLOCKY  0x8

#define STMASK  0x3

#define XMASK   0x40
#define YMASK   0x80


#define WIDTH    25

#define CHWIDTH    2
#define CHWIDTH2   20

#define CHHEIGHT   24

#define VERTMARGIN  2
#define VERTSHIFT   8

#define HORIZMARGIN 2
#define HORIZSHIFT  4

#define CROSSTYPE  0
#define SQUARETYPE 1

#define DEFWSQDIR (8+1+4+2)


extern char    griddata[MAXX][MAXY];
extern char    gridstate[MAXX][MAXY];
extern char    gridcnt[MAXX][MAXY];

extern int maxx;	// grid x cells
extern int maxy;	// grid y cells
extern int meshx;	// size of x cell
extern int meshy;	// size of y cell
extern int cursx;
extern int cursy;
extern int lcursx;
extern int lcursy;


extern int zx0;                            /* coords of zone */
extern int zy0;
extern int zx1;
extern int zy1;

extern int nsol;                      /* number of  solutions          */
extern int solwidth;                /* number of  words per solution */
extern int solheight;              /* height of  solution in window */
extern int solxwidth;

extern int splitfraction;
extern int loadwidth;
extern int loadheight;


extern int      solnleading;
extern int      solnintheight;
extern int      solnextheight;
extern int      solncharwidth;
extern int      solnmaxn;
extern int      minsollen;
extern int      dmask;
extern int      drawsolutions;

extern int      editleading;
extern int      editheight;
extern int      editwidth;


extern int cursorcolour;
extern int zonecolour;
extern int textcolour;
extern int gridcolour;
extern int fillcolour;
extern int emptycolour;
extern int gridmeshratio;


extern font_description textfont;
extern font_description cluefont;
extern font_description editfont;
extern font_description solnfont;
extern font_description defeditfont;
extern font_description defsolnfont;




extern int    mainhandle;
extern int    gridhandle;
extern int    solnhandle;
extern int    buttonshandle;

extern int    gridtype;


extern os_error * maindynamic(int * menu,char * handle,int window);
extern os_error * maindecode(int * menu,int window);
extern os_error * setgridtype(int gtype);
extern os_error * setgridtypeload(int gtype);
extern os_error * openmainwindow(void);
extern os_error * loadopenwindow(void);

extern os_error * setparameters(void);
extern os_error * readdefaultparameters(void);
extern os_error * writedefaultparameters(void);

extern os_error * buttonssolve(int solve);
extern int        buttonsevent(void);
extern void       buttonssoln(int n);
extern void       buttonssetevent(void);

extern os_error * updategridtitle(void);


